
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ReviewsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const reviews = await db.reviews.create(
            {
                id: data.id || undefined,
        
        target_type: data.target_type
        ||
        null
            ,
            
        rating: data.rating
        ||
        null
            ,
            
        comment: data.comment
        ||
        null
            ,
            
        reviewed_at: data.reviewed_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await reviews.setOrder( data.order || null, {
            transaction,
        });
        
        await reviews.setAuthor( data.author || null, {
            transaction,
        });
        
        await reviews.setStore( data.store || null, {
            transaction,
        });
        
        await reviews.setCourier( data.courier || null, {
            transaction,
        });
        
        await reviews.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return reviews;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const reviewsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                target_type: item.target_type
            ||
            null
            ,
            
                rating: item.rating
            ||
            null
            ,
            
                comment: item.comment
            ||
            null
            ,
            
                reviewed_at: item.reviewed_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const reviews = await db.reviews.bulkCreate(reviewsData, { transaction });

        // For each item created, replace relation files
        

        return reviews;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const reviews = await db.reviews.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.target_type !== undefined) updatePayload.target_type = data.target_type;
        
        
        if (data.rating !== undefined) updatePayload.rating = data.rating;
        
        
        if (data.comment !== undefined) updatePayload.comment = data.comment;
        
        
        if (data.reviewed_at !== undefined) updatePayload.reviewed_at = data.reviewed_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await reviews.update(updatePayload, {transaction});

        
        
        if (data.order !== undefined) {
            await reviews.setOrder(
              
              data.order,
              
              { transaction }
            );
        }
        
        if (data.author !== undefined) {
            await reviews.setAuthor(
              
              data.author,
              
              { transaction }
            );
        }
        
        if (data.store !== undefined) {
            await reviews.setStore(
              
              data.store,
              
              { transaction }
            );
        }
        
        if (data.courier !== undefined) {
            await reviews.setCourier(
              
              data.courier,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await reviews.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return reviews;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const reviews = await db.reviews.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of reviews) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of reviews) {
                await record.destroy({transaction});
            }
        });


        return reviews;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const reviews = await db.reviews.findByPk(id, options);

        await reviews.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await reviews.destroy({
            transaction
        });

        return reviews;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const reviews = await db.reviews.findOne(
            { where },
            { transaction },
        );

        if (!reviews) {
            return reviews;
        }

        const output = reviews.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.order = await reviews.getOrder({
            transaction
        });
        
        
        output.author = await reviews.getAuthor({
            transaction
        });
        
        
        output.store = await reviews.getStore({
            transaction
        });
        
        
        output.courier = await reviews.getCourier({
            transaction
        });
        
        
        output.organizations = await reviews.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.orders,
        as: 'order',
        
        where: filter.order ? {
          [Op.or]: [
            { id: { [Op.in]: filter.order.split('|').map(term => Utils.uuid(term)) } },
            {
              order_number: {
                [Op.or]: filter.order.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'author',
        
        where: filter.author ? {
          [Op.or]: [
            { id: { [Op.in]: filter.author.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.author.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.stores,
        as: 'store',
        
        where: filter.store ? {
          [Op.or]: [
            { id: { [Op.in]: filter.store.split('|').map(term => Utils.uuid(term)) } },
            {
              store_name: {
                [Op.or]: filter.store.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'courier',
        
        where: filter.courier ? {
          [Op.or]: [
            { id: { [Op.in]: filter.courier.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.courier.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.comment) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'reviews',
                        'comment',
                        filter.comment,
                    ),
                };
            }
            

            
            

            
            if (filter.ratingRange) {
                const [start, end] = filter.ratingRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    rating: {
                    ...where.rating,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    rating: {
                    ...where.rating,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.reviewed_atRange) {
                const [start, end] = filter.reviewed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    reviewed_at: {
                    ...where.reviewed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    reviewed_at: {
                    ...where.reviewed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.target_type) {
                where = {
                    ...where,
                target_type: filter.target_type,
            };
            }
            


      

      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.reviews.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'reviews',
                        'comment',
                        query,
                    ),
                ],
            };
        }

        const records = await db.reviews.findAll({
            attributes: [ 'id', 'comment' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['comment', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.comment,
        }));
    }

    
};

